VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Begin VB.Form mainWindow 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Game of Life"
   ClientHeight    =   9375
   ClientLeft      =   30
   ClientTop       =   315
   ClientWidth     =   11250
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   9375
   ScaleWidth      =   11250
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame statisticsFrame 
      Caption         =   "Statistics"
      Height          =   855
      Left            =   120
      TabIndex        =   21
      Top             =   6000
      Width           =   9375
      Begin VB.Label aliveLabel 
         Caption         =   "Current Number of Lives:"
         Height          =   255
         Left            =   120
         TabIndex        =   23
         Top             =   480
         Width           =   3615
      End
      Begin VB.Label elapsedLabel 
         Caption         =   "Number of Generations Elapsed:"
         Height          =   255
         Left            =   120
         TabIndex        =   22
         Top             =   240
         Width           =   2895
      End
   End
   Begin VB.CommandButton quitButton 
      Caption         =   "&Quit"
      Height          =   375
      Left            =   9840
      TabIndex        =   13
      Top             =   8640
      Width           =   1215
   End
   Begin VB.CommandButton pauseButton 
      Caption         =   "&Pause"
      Height          =   375
      Left            =   9840
      TabIndex        =   12
      Top             =   8160
      Width           =   1215
   End
   Begin VB.Frame settingsFrame 
      Caption         =   "Simulation Settings"
      Height          =   2055
      Left            =   120
      TabIndex        =   6
      Top             =   6960
      Width           =   9375
      Begin VB.VScrollBar imageScroll 
         Height          =   375
         Left            =   8640
         TabIndex        =   20
         Top             =   240
         Width           =   255
      End
      Begin MSComctlLib.Slider xSlider 
         Height          =   255
         Left            =   1080
         TabIndex        =   17
         Top             =   360
         Width           =   3015
         _ExtentX        =   5318
         _ExtentY        =   450
         _Version        =   393216
         Min             =   10
         Max             =   50
         SelStart        =   10
         Value           =   10
      End
      Begin MSComctlLib.Slider percolationSlider 
         Height          =   255
         Left            =   2640
         TabIndex        =   10
         Top             =   840
         Width           =   6615
         _ExtentX        =   11668
         _ExtentY        =   450
         _Version        =   393216
         LargeChange     =   10
         Max             =   100
      End
      Begin MSComctlLib.Slider timeSlider 
         Height          =   255
         Left            =   2640
         TabIndex        =   7
         Top             =   1200
         Width           =   6615
         _ExtentX        =   11668
         _ExtentY        =   450
         _Version        =   393216
         Min             =   1
         Max             =   60
         SelStart        =   1
         Value           =   1
      End
      Begin MSComctlLib.Slider ySlider 
         Height          =   255
         Left            =   4320
         TabIndex        =   18
         Top             =   360
         Width           =   3015
         _ExtentX        =   5318
         _ExtentY        =   450
         _Version        =   393216
         Min             =   10
         Max             =   50
         SelStart        =   10
         Value           =   10
      End
      Begin VB.Image selectedImage 
         Height          =   375
         Left            =   8160
         Top             =   240
         Width           =   495
      End
      Begin VB.Label imageLabel 
         Caption         =   "Image:"
         Height          =   255
         Left            =   7560
         TabIndex        =   19
         Top             =   360
         Width           =   615
      End
      Begin VB.Label yLabel 
         Alignment       =   1  'Right Justify
         Caption         =   "Y:"
         Height          =   255
         Left            =   4080
         TabIndex        =   16
         Top             =   360
         Width           =   255
      End
      Begin VB.Label xLabel 
         Alignment       =   1  'Right Justify
         Caption         =   "X:"
         Height          =   255
         Left            =   840
         TabIndex        =   15
         Top             =   360
         Width           =   255
      End
      Begin VB.Label gridSizeLabel 
         Caption         =   "Grid Size"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   360
         Width           =   735
         WordWrap        =   -1  'True
      End
      Begin VB.Label noteLabel 
         Caption         =   "Some changes will not go into effect until the start of a new game. "
         Height          =   375
         Left            =   120
         TabIndex        =   11
         Top             =   1560
         Width           =   8055
         WordWrap        =   -1  'True
      End
      Begin VB.Label percolationLabel 
         Alignment       =   1  'Right Justify
         Caption         =   "Percolation Probability (1%-100%):"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   840
         Width           =   2535
         WordWrap        =   -1  'True
      End
      Begin VB.Label timeLabel 
         Alignment       =   1  'Right Justify
         Caption         =   "Lifetime of Generation (in Seconds):"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   1200
         Width           =   2535
      End
   End
   Begin VB.CommandButton newGameButton 
      Caption         =   "&New Game"
      Height          =   375
      Left            =   9840
      TabIndex        =   5
      Top             =   7680
      Width           =   1215
   End
   Begin MSComctlLib.StatusBar statusBar 
      Align           =   2  'Align Bottom
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   9120
      Width           =   11250
      _ExtentX        =   19844
      _ExtentY        =   450
      Style           =   1
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   1
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   1
            Object.Width           =   19791
         EndProperty
      EndProperty
   End
   Begin VB.Timer timer 
      Interval        =   5000
      Left            =   9600
      Top             =   7440
   End
   Begin VB.PictureBox nextGenerationPicture 
      AutoRedraw      =   -1  'True
      Height          =   5325
      Left            =   5640
      ScaleHeight     =   5475
      ScaleMode       =   0  'User
      ScaleWidth      =   4894.728
      TabIndex        =   1
      Top             =   480
      Width           =   5445
   End
   Begin VB.PictureBox currentGenerationPicture 
      AutoRedraw      =   -1  'True
      Height          =   5325
      Left            =   120
      ScaleHeight     =   6119.633
      ScaleMode       =   0  'User
      ScaleWidth      =   4667.63
      TabIndex        =   0
      Top             =   480
      Width           =   5475
   End
   Begin MSComctlLib.ImageList imageList 
      Left            =   10320
      Top             =   6840
      _ExtentX        =   794
      _ExtentY        =   794
      BackColor       =   -2147483643
      ImageWidth      =   20
      ImageHeight     =   20
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   55
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":0442
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":075C
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":0A76
            Key             =   ""
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":0D90
            Key             =   ""
         EndProperty
         BeginProperty ListImage5 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":10AA
            Key             =   ""
         EndProperty
         BeginProperty ListImage6 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":1C7C
            Key             =   ""
         EndProperty
         BeginProperty ListImage7 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":284E
            Key             =   ""
         EndProperty
         BeginProperty ListImage8 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":3420
            Key             =   ""
         EndProperty
         BeginProperty ListImage9 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":3FF2
            Key             =   ""
         EndProperty
         BeginProperty ListImage10 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":4BC4
            Key             =   ""
         EndProperty
         BeginProperty ListImage11 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":5796
            Key             =   ""
         EndProperty
         BeginProperty ListImage12 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":6368
            Key             =   ""
         EndProperty
         BeginProperty ListImage13 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":6F3A
            Key             =   ""
         EndProperty
         BeginProperty ListImage14 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":7B0C
            Key             =   ""
         EndProperty
         BeginProperty ListImage15 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":86DE
            Key             =   ""
         EndProperty
         BeginProperty ListImage16 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":92B0
            Key             =   ""
         EndProperty
         BeginProperty ListImage17 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":9E82
            Key             =   ""
         EndProperty
         BeginProperty ListImage18 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":AA54
            Key             =   ""
         EndProperty
         BeginProperty ListImage19 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":B626
            Key             =   ""
         EndProperty
         BeginProperty ListImage20 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":C1F8
            Key             =   ""
         EndProperty
         BeginProperty ListImage21 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":CDCA
            Key             =   ""
         EndProperty
         BeginProperty ListImage22 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":D99C
            Key             =   ""
         EndProperty
         BeginProperty ListImage23 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":E56E
            Key             =   ""
         EndProperty
         BeginProperty ListImage24 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":F140
            Key             =   ""
         EndProperty
         BeginProperty ListImage25 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":FD12
            Key             =   ""
         EndProperty
         BeginProperty ListImage26 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":108E4
            Key             =   ""
         EndProperty
         BeginProperty ListImage27 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":114B6
            Key             =   ""
         EndProperty
         BeginProperty ListImage28 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":12088
            Key             =   ""
         EndProperty
         BeginProperty ListImage29 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":123A2
            Key             =   ""
         EndProperty
         BeginProperty ListImage30 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":126BC
            Key             =   ""
         EndProperty
         BeginProperty ListImage31 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":129D6
            Key             =   ""
         EndProperty
         BeginProperty ListImage32 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":135A8
            Key             =   ""
         EndProperty
         BeginProperty ListImage33 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":138C2
            Key             =   ""
         EndProperty
         BeginProperty ListImage34 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":13BDC
            Key             =   ""
         EndProperty
         BeginProperty ListImage35 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":13EF6
            Key             =   ""
         EndProperty
         BeginProperty ListImage36 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":14210
            Key             =   ""
         EndProperty
         BeginProperty ListImage37 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":1452A
            Key             =   ""
         EndProperty
         BeginProperty ListImage38 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":14844
            Key             =   ""
         EndProperty
         BeginProperty ListImage39 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":14B5E
            Key             =   ""
         EndProperty
         BeginProperty ListImage40 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":14E78
            Key             =   ""
         EndProperty
         BeginProperty ListImage41 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":15192
            Key             =   ""
         EndProperty
         BeginProperty ListImage42 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":154AC
            Key             =   ""
         EndProperty
         BeginProperty ListImage43 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":157C6
            Key             =   ""
         EndProperty
         BeginProperty ListImage44 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":15AE0
            Key             =   ""
         EndProperty
         BeginProperty ListImage45 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":15DFA
            Key             =   ""
         EndProperty
         BeginProperty ListImage46 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":16114
            Key             =   ""
         EndProperty
         BeginProperty ListImage47 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":1642E
            Key             =   ""
         EndProperty
         BeginProperty ListImage48 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":16748
            Key             =   ""
         EndProperty
         BeginProperty ListImage49 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":16A62
            Key             =   ""
         EndProperty
         BeginProperty ListImage50 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":16D7C
            Key             =   ""
         EndProperty
         BeginProperty ListImage51 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":17096
            Key             =   ""
         EndProperty
         BeginProperty ListImage52 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":17C68
            Key             =   ""
         EndProperty
         BeginProperty ListImage53 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":1883A
            Key             =   ""
         EndProperty
         BeginProperty ListImage54 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":1940C
            Key             =   ""
         EndProperty
         BeginProperty ListImage55 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Main.frx":19FDE
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.Label nextGeneration 
      Alignment       =   2  'Center
      Caption         =   "Next Generation"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   6360
      TabIndex        =   3
      Top             =   0
      Width           =   3975
   End
   Begin VB.Label currentGenerationLabel 
      Alignment       =   2  'Center
      Caption         =   "Current Generation"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   720
      TabIndex        =   2
      Top             =   0
      Width           =   3975
   End
End
Attribute VB_Name = "mainWindow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'/*
'Game of Life
'frm_Main.frm- UI program
'Copyright  (C) 1997-2000 Hugues Johnson
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
'the GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'*/

Private Const INIT_SLIDER As Long = 5
Private Const INIT_SCROLL_X As Long = 20
Private Const INIT_SCROLL_Y As Long = 20
Private Const INIT_PERCOLATION As Long = 50
Private Const INIT_GRID_X As Integer = 20
Private Const INIT_GRID_Y As Integer = 20




Private Sub Form_Load()
    
    gameRunning = False
    
    Me.timeSlider.Value = INIT_SLIDER

    '/* make sure picture boxes are the same size */
    Me.nextGenerationPicture.Height = Me.currentGenerationPicture.Height
    Me.nextGenerationPicture.Width = Me.currentGenerationPicture.Width
    Me.nextGenerationPicture.ScaleHeight = Me.currentGenerationPicture.ScaleHeight
    Me.nextGenerationPicture.ScaleWidth = Me.currentGenerationPicture.ScaleWidth
    
    Me.xSlider.Value = INIT_SCROLL_X
    Me.ySlider.Value = INIT_SCROLL_Y
    Me.percolationSlider.Value = INIT_PERCOLATION
    changeGridSize INIT_GRID_X, INIT_GRID_Y
        
    '/* set the size & position for selectedImage and imageScroll */
    Me.selectedImage.Height = Me.imageList.ListImages(1).Picture.Height
    Me.selectedImage.Width = Me.imageList.ImageWidth
    Me.selectedImage.Picture = Me.imageList.ListImages(1).Picture
    Me.imageScroll.Min = 1
    Me.imageScroll.Max = imageList.ListImages.Count
    Me.imageScroll.Left = Me.selectedImage.Left + Me.selectedImage.Width + 50
    Me.imageScroll.Height = Me.selectedImage.Height
    Me.imageScroll.Value = Me.imageScroll.Max
       
    Me.statusBar.SimpleText = "Press 'New Game' button to start simulation"
    noteLabel.Caption = "Some changes will not go into effect until the start of a new game." & vbNewLine & "Some character images are borrowed from Falcom (http://www.falcom.com/)."
       
End Sub




Private Sub imageScroll_Change()
    Dim imageIndex As Integer
    
    imageIndex = Me.imageScroll.Value
    Me.selectedImage.Picture = Me.imageList.ListImages(imageIndex).Picture

End Sub


Private Sub newGameButton_Click()
    
    '/* reset counter */
    elapsed = 0
    '/* set the grid size */
    changeGridSize CInt(Me.xSlider.Value), CInt(Me.ySlider.Value)
    '/* start new game */
    startNewGame Me.currentGenerationPicture, Me.nextGenerationPicture, CSng(Me.percolationSlider.Value / 100)
    '/* draw generations */
    drawGenerations Me.currentGenerationPicture, Me.nextGenerationPicture, Me.imageList.ListImages(Me.imageScroll.Value).Picture

End Sub


Private Sub pauseButton_Click()

    If (gameRunning) Then
        gameRunning = False
        Me.pauseButton.Caption = "&Unpause"
        Me.statusBar.SimpleText = "Simulation paused"
    Else
        gameRunning = True
        Me.pauseButton.Caption = "&Pause"
        Me.statusBar.SimpleText = vbNullString
    End If

End Sub


Private Sub quitButton_Click()
    Dim result As VbMsgBoxResult
    
    result = MsgBox("End this program?", vbYesNo + vbQuestion, App.Title)
    If (result = vbYes) Then
        End
    End If
   
End Sub


Private Sub timeSlider_Change()

    Me.timer.Interval = 1000 * Me.timeSlider.Value

End Sub

Private Sub timer_Timer()

    If (gameRunning) Then
        elapsed = elapsed + 1
        Me.statusBar.SimpleText = "Determining Next Generation...."
        determineNextGeneration
        statusBar.SimpleText = "Drawing...."
        drawGenerations Me.currentGenerationPicture, Me.nextGenerationPicture, Me.imageList.ListImages(Me.imageScroll.Value).Picture
        statusBar.SimpleText = vbNullString
        elapsedLabel.Caption = "Number of Generations Elapsed: " & Trim$(CStr(elapsed))
        aliveLabel.Caption = "Current Number of Lives: " & Trim$(CStr(currentAlive))
    End If
    
End Sub







